blog/urls.py
from django.urls import path

from blog.views import contacts, ShowNewsView, NewsDetailView, CreateNewsView, UpdateNewsView, DeleteNewsView, \
    UserAllNewsView

app_name = 'blog'

urlpatterns = [
    path('', ShowNewsView.as_view(), name='blog-home'),
    path('user/<str:username>/', UserAllNewsView.as_view(), name='user-news'),
    path('news/<int:pk>/', NewsDetailView.as_view(), name='news-detail'),
    path('news/add/', CreateNewsView.as_view(), name='news-create'),
    path('news/<int:pk>/update/', UpdateNewsView.as_view(), name='news-update'),
    path('news/<int:pk>/delete/', DeleteNewsView.as_view(), name='news-delete'),
    path('contacts/', contacts, name='blog-contacts')
]

lcProger/urls.py
from django.conf import settings
from django.contrib.auth import views

from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('blog.urls')),
    path('registration/', include('users.urls')),
    path('password_reset/', views.PasswordResetView.as_view(template_name='users/pass_reset.html'), name='pass-reset'),
    path('password_reset/done/>',
         views.PasswordResetDoneView.as_view(template_name='users/password_reset_done.html'),
         name='password_reset_done'),
    path('password_reset_confirm/<uidb64>/<token>/',
         views.PasswordResetConfirmView.as_view(template_name='users/password_reset_confirm.html'),
         name='password_reset_confirm'),
    path('password_reset_complete/',
         views.PasswordResetCompleteView.as_view(template_name='users/password_reset_complete.html'),
         name='password_reset_complete'),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

blog/models.py
from django.contrib.auth.models import User
from django.db import models
from django.urls import reverse
from django.utils import timezone


class News(models.Model):
    title = models.CharField(max_length=100)
    text = models.TextField()
    author = models.ForeignKey(User, on_delete=models.CASCADE)
    date = models.DateTimeField(default=timezone.now)

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse('blog:news-detail', kwargs={'pk': self.pk})

blog/views.py
from django.contrib.auth.mixins import LoginRequiredMixin, UserPassesTestMixin
from django.contrib.auth.models import User
from django.http import HttpRequest
from django.shortcuts import render, get_object_or_404
from django.views.generic import ListView, DetailView, CreateView, UpdateView, DeleteView

from blog.models import News


def home(request: HttpRequest):
    data = {
        'news': News.objects.select_related('author').all(),
        'title': 'Blog home page'
    }
    return render(request, 'blog/home.html', data)


class ShowNewsView(ListView):
    model = News
    template_name = 'blog/home.html'
    context_object_name = 'news'
    ordering = ['-date']
    paginate_by = 5

    def get_context_data(self, *, object_list=None, **kwargs):
        context = super(ShowNewsView, self).get_context_data(**kwargs)
        context['title'] = "Главная страница блога"
        return context


class UserAllNewsView(ListView):
    model = News
    template_name = 'blog/user_news.html'
    context_object_name = 'news'
    paginate_by = 5

    def get_queryset(self):
        user = get_object_or_404(User, username=self.kwargs.get('username'))
        return News.objects.filter(author=user).order_by('-date')

    def get_context_data(self, *, object_list=None, **kwargs):
        context = super(UserAllNewsView, self).get_context_data(**kwargs)
        context['title'] = "Главная страница блога"
        return context


class NewsDetailView(DetailView):
    model = News

    def get_context_data(self, *, object_list=None, **kwargs):
        context = super(NewsDetailView, self).get_context_data(**kwargs)
        context['title'] = News.objects.filter(pk=self.kwargs['pk']).first()
        return context


class CreateNewsView(LoginRequiredMixin, CreateView):
    model = News
    fields = ['title', 'text']

    def form_valid(self, form):
        form.instance.author = self.request.user
        return super().form_valid(form)


class UpdateNewsView(LoginRequiredMixin, UserPassesTestMixin, UpdateView):
    model = News
    fields = ['title', 'text']

    def form_valid(self, form):
        form.instance.author = self.request.user
        return super().form_valid(form)

    def test_func(self):
        news = self.get_object()
        if self.request.user == news.author:
            return True
        return False


class DeleteNewsView(LoginRequiredMixin, UserPassesTestMixin, DeleteView):
    model = News
    success_url = '/'

    def test_func(self):
        news = self.get_object()
        if self.request.user == news.author:
            return True
        return False


def contacts(request):
    return render(request, 'blog/contacts.html')

blog/templates/blog/contacts.html
{% extends 'base.html' %}

{% block title %}
    Contacts
{% endblock %}

{% block body %}
    <h1>Contacts</h1>
{% endblock %}

{% block aside_news_section %}
    <h3><b>10 films and series for programmers</b></h3>
    <img class="img-thumbnail mb-1"
         src="https://itproger.com/img/news/1477674462.jpg">
    <p>When you get on the path of programming, you really want to watch any films or series on this topic.
        We present you a selection of 10 films for programmers.</p>
    <a href="https://itproger.com/news/10-filmov-i-serialov-dlya-programmistov" target="_blank">
        <button class="btn btn-warning">View</button>
    </a>
{% endblock %}

blog/templates/blog/home.html
{% extends 'base.html' %}

{% block title %}
    {{ title }}
{% endblock %}

{% block body %}
    {% for post in news %}
        <div class="alert alert-light">
            <h3>{{ post.title }}</h3>
            <p>{{ post.text|striptags|truncatechars:200 }}</p>
            <div class="d-flex text-body-secondary pt-3">

                {% if post.author.profile.img %}
                    <div>
                        <img src="{{ post.author.profile.img.url }}" alt="{{ post.author }}" class="user_image">
                    </div>
                {% endif %}

                <div class="mt-2">

                    {% if post.author %}
                        <b>Author:</b>
                        <a href="{% url 'blog:user-news' post.author %}">{{ post.author }}</a>
                    {% endif %}

                    <span class="text-muted"><p><b>Date:</b> {{ post.date|date:"d E Y, H:i:s " }}</p></span>
                </div>
            </div>
            <a href="{% url 'blog:news-detail' post.id %}" class="btn btn-outline-warning">Читать далее</a>
        </div>
    {% endfor %}

    {% if is_paginated %}
        {% if page_obj.has_previous %}
            <a href="/" class="btn btn-outline-warning">Начало</a>
            <a href="?page={{ page_obj.previous_page_number }}" class="btn btn-outline-warning">Предыдгщая</a>
        {% endif %}

        {% for num in page_obj.paginator.page_range %}
            {% if num == page_obj.number %}
                <button class="btn btn-warning">{{ num }}</button>
            {% elif num > page_obj.number|add:'-3' and num < page_obj.number|add:'3' %}
                <a href="?page={{ num }}" class="btn btn-outline-warning">{{ num }}</a>
            {% endif %}
        {% endfor %}

        {% if page_obj.has_next %}
            <a href="?page={{ page_obj.next_page_number }}" class="btn btn-outline-warning">Следующая</a>
            <a href="?page={{ page_obj.paginator.num_pages }}" class="btn btn-outline-warning">Послудняя</a>
        {% endif %}
    {% endif %}
{% endblock %}

{% block aside_news_section %}
    <h3><b>10 films and series for programmers</b></h3>
    <img class="img-thumbnail mb-1"
         src="https://itproger.com/img/news/1477674462.jpg">
    <p>When you get on the path of programming, you really want to watch any films or series on this topic.
        We present you a selection of 10 films for programmers.</p>
    <a href="https://itproger.com/news/10-filmov-i-serialov-dlya-programmistov" target="_blank">
        <button class="btn btn-warning">View</button>
    </a>
{% endblock %}

blog/templates/blog/news_confirm_delete.html
{% extends 'base.html' %}

{% block title %}
    Удаление статьи
{% endblock %}

{% block body %}
    <div class="form-section alert alert-light">
        <h2>Удалить статью "{{ object.title }}"?</h2>
        <form method="post">
            {% csrf_token %}
            <button type="submit" class="btn btn-outline-danger">Да</button>
            <a href="{% url 'blog:news-detail' object.id %}" class="btn btn-outline-success">Нет</a>
        </form>
    </div>
{% endblock %}

{% block aside_news_section %}
    <h3><b>10 films and series for programmers</b></h3>
    <img class="img-thumbnail mb-1"
         src="https://itproger.com/img/news/1477674462.jpg">
    <p>When you get on the path of programming, you really want to watch any films or series on this topic.
        We present you a selection of 10 films for programmers.</p>
    <a href="https://itproger.com/news/10-filmov-i-serialov-dlya-programmistov" target="_blank">
        <button class="btn btn-warning">View</button>
    </a>
{% endblock %}

blog/templates/blog/news_detail.html
{% extends 'base.html' %}

{% block title %}
    {{ title }}
{% endblock %}

{% block body %}
    <div class="alert alert-light">
        <a href="{% url 'blog:blog-home' %}">Назад</a>
        <h3>{{ object.title }}</h3>
        <p>{{ object.text|safe }}</p>
        <div class="d-flex text-body-secondary pt-3">
            {% if object.author.profile.img %}
                <div>
                    <img src="{{ object.author.profile.img.url }}" alt="{{ object.author }}" class="user_image">
                </div>
            {% endif %}
            <div class="mt-2">
                {% if object.author %}
                    <b>Author:</b>
                    <a href="{% url 'blog:user-news' object.author %}">{{ object.author }}</a>
                {% endif %}
                <span class="text-muted"><p><b>Date:</b> {{ object.date|date:"d E Y, H:i:s " }}</p></span>
            </div>
        </div>
        {#        <a href="{% url 'blog:blog-home' %}" class="btn btn-outline-warning">Назад</a>#}
        {% if user == object.author %}
            <hr>
            <a href="{% url 'blog:news-update' object.id %}" class="btn btn-outline-warning">Обновить</a>
            <a href="{% url 'blog:news-delete' object.id %}" class="btn btn-outline-danger">Удалить</a>
        {% endif %}
    </div>
{% endblock %}

{% block aside_news_section %}
    <h3><b>10 films and series for programmers</b></h3>
    <img class="img-thumbnail mb-1"
         src="https://itproger.com/img/news/1477674462.jpg">
    <p>When you get on the path of programming, you really want to watch any films or series on this topic.
        We present you a selection of 10 films for programmers.</p>
    <a href="https://itproger.com/news/10-filmov-i-serialov-dlya-programmistov" target="_blank">
        <button class="btn btn-warning">View</button>
    </a>
{% endblock %}

blog/templates/blog/news_form.html
{% extends 'base.html' %}
{% load crispy_forms_filters %}
{% load crispy_forms_tags %}

{% block title %}
    Добавление новой статьи
{% endblock %}

{% block body %}
    <div class="form-section alert alert-light">
        <h2>Добавление новой статьи</h2>
        <form method="post">
            {% csrf_token %}
            {{ form|crispy }}
            <button type="submit" class="btn btn-outline-warning">Опубликовать</button>
        </form>
    </div>
{% endblock %}

{% block aside_news_section %}
    <h3><b>10 films and series for programmers</b></h3>
    <img class="img-thumbnail mb-1"
         src="https://itproger.com/img/news/1477674462.jpg">
    <p>When you get on the path of programming, you really want to watch any films or series on this topic.
        We present you a selection of 10 films for programmers.</p>
    <a href="https://itproger.com/news/10-filmov-i-serialov-dlya-programmistov" target="_blank">
        <button class="btn btn-warning">View</button>
    </a>
{% endblock %}

blog/templates/blog/user_news.html
{% extends 'base.html' %}

{% block title %}
    {{ title }}
{% endblock %}

{% block body %}
    <h2>Все статьи пользователя {{ views.kwargs.username }}</h2>
    <h4>Колличество: {{ page_obj.paginator.conunt }}</h4>
    {% for post in news %}
        <div class="alert alert-light">
            <h3>{{ post.title }}</h3>
            <p>{{ post.text|striptags|truncatechars:200 }}</p>
            <div class="d-flex text-body-secondary pt-3">

                {% if post.author.profile.img %}
                    <div>
                        <img src="{{ post.author.profile.img.url }}" alt="{{ post.author }}" class="user_image">
                    </div>
                {% endif %}

                <div class="mt-2">

                    {% if post.author %}
                        <b>Author:</b>
                        <a href="{% url 'blog:user-news' post.author %}">{{ post.author }}</a>
                    {% endif %}

                    <span class="text-muted"><p><b>Date:</b> {{ post.date|date:"d E Y, H:i:s " }}</p></span>
                </div>
            </div>
            <a href="{% url 'blog:news-detail' post.id %}" class="btn btn-outline-warning">Читать далее</a>
        </div>
    {% endfor %}

    {% if is_paginated %}
        {% if page_obj.has_previous %}
            <a href="?page=1" class="btn btn-outline-warning">Начало</a>
            <a href="?page={{ page_obj.previous_page_number }}" class="btn btn-outline-warning">Предыдгщая</a>
        {% endif %}

        {% for num in page_obj.paginator.page_range %}
            {% if num == page_obj.number %}
                <button class="btn btn-warning">{{ num }}</button>
            {% elif num > page_obj.number|add:'-3' and num < page_obj.number|add:'3' %}
                <a href="?page={{ num }}" class="btn btn-outline-warning">{{ num }}</a>
            {% endif %}
        {% endfor %}

        {% if page_obj.has_next %}
            <a href="?page={{ page_obj.next_page_number }}" class="btn btn-outline-warning">Следующая</a>
            <a href="?page={{ page_obj.paginator.num_pages }}" class="btn btn-outline-warning">Послудняя</a>
        {% endif %}
    {% endif %}
{% endblock %}

{% block aside_news_section %}
    <h3><b>10 films and series for programmers</b></h3>
    <img class="img-thumbnail mb-1"
         src="https://itproger.com/img/news/1477674462.jpg">
    <p>When you get on the path of programming, you really want to watch any films or series on this topic.
        We present you a selection of 10 films for programmers.</p>
    <a href="https://itproger.com/news/10-filmov-i-serialov-dlya-programmistov" target="_blank">
        <button class="btn btn-warning">View</button>
    </a>
{% endblock %}